/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.javafx;

import java.net.URL;
import java.util.ResourceBundle;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.concurrent.Task;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Button;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.Pane;
import org.controlsfx.control.StatusBar;

/**
 * FXML Controller class
 *
 * @author c1278778
 */
public class FXMLController implements Initializable {
    
    @FXML
    private BorderPane borderPaneMain;
    private StatusBar statusBar = new StatusBar();
    private Task copyWorker;
    
    /**
     * Initializes the controller class.
     */
    @Override
    public void initialize(URL url, ResourceBundle rb) { 
        
        Button info = new Button("Informações-Click");        
        statusBar.getLeftItems().add(info);        
        statusBar.setProgress(0);
        
        //Seta statusBar barra no rodape
        borderPaneMain.setBottom(statusBar);
        
        //AAção do click em planejamento
        info.setOnAction(new EventHandler<ActionEvent>() {
            public void handle(ActionEvent event) {
                
                copyWorker = createWorker();
                
                statusBar.progressProperty().unbind();
                statusBar.progressProperty().bind(copyWorker.progressProperty());

                copyWorker.messageProperty().addListener(new ChangeListener<String>() {
                    public void changed(ObservableValue<? extends String> observable, String oldValue, String newValue) {
                        System.out.println(newValue);
                    }
                });

                new Thread(copyWorker).start();
            }
        });
    }
    
    //Ação do click em execução
    public Task createWorker() {
        return new Task() {
            @Override
            protected Object call() throws Exception {
                for (int i = 0; i < 10; i++) {
                    Thread.sleep(2000);
                    updateMessage("2000 milliseconds");
                    updateProgress(i + 1, 10);
                }
                return true;
            }
        };
    }

}
